/*
TECNISA - TECNOLOGIA EM INFORMTICA

NOME: APURAC_MANDATO

DESCRIO:
   PROCEDIMENTO PARA APURAO DE FATURAMENTO DE CLIENTES EM FILIAIS
   QUE UTILIZAM O TIPO DE CONTRATO MANDATO.

CRIAO:
11/04/2001 - DISNEI H. DE MOURA

@C:\WIN_PRJ\SQL\END_CONV\ORACLE\6204_FAISTP_APUMANDATO.SQL;

--   RAISE_APPLICATION_ERROR(-20501,V_IDTAXAADM, TRUE);
*/

CREATE OR REPLACE PROCEDURE APURAC_MANDATO(
   P_CDFILIAPUR  IN FILIAL.CDFILIAL%TYPE,
   P_CDFILIPROC  IN FILIAL.CDFILIAL%TYPE,
   P_CDCLIENTE   IN CLIENTE.CDCLIENTE%TYPE,
   P_DATAINI     IN DATE,
   P_DATAFIM     IN DATE,
   P_NRAPURACFAT IN NOTAFISCAL.NRAPURACFAT%TYPE,
   P_NRLANCTONF  IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_IDNFCOMPRA  IN VARCHAR,
   P_DTINIAPUR   IN DATE  DEFAULT NULL,
   P_DTFINAPUR   IN DATE  DEFAULT NULL,
   P_VRNOTACRED  IN FLOAT DEFAULT 0,
   P_VRBASENFCMP IN FLOAT DEFAULT 0,
   P_DATAPROC    IN DATE) AS

   V_CDEMPRATAC   EMPRESA.CDEMPRESA%TYPE;
   V_CDINSCATAC   INSCRESTAD.CDINSCESTA%TYPE;
   V_CDINSCMUNI   INSCRMUNICIP.CDINSCMUNI%TYPE;
   V_CDEMPROPER   EMPRESA.CDEMPRESA%TYPE;
   V_CDSERIE      SERIENF.CDSERIE%TYPE;
   V_CDSERIEDESP  SERIENF.CDSERIE%TYPE;
   V_CDIMPOSTO    IMPOSTO.CDIMPOSTO%TYPE;

   V_CDFILIAPUR   CTRLAPURFAT.CDFILIAPUR%TYPE;
   V_DTINIAPURAC  CTRLAPURFAT.DTINIAPURAC%TYPE;
   V_DTFIMAPURAC  CTRLAPURFAT.DTFIMAPURAC%TYPE;

   V_NRLANCTONF   NOTAFISCAL.NRLANCTONF%TYPE;

   V_NRLANCCMP    NOTAFISCAL.NRLANCTONF%TYPE;

   V_VRNOTAFISC   NOTAFISCAL.VRNOTAFISC%TYPE;

   V_NRLANCESTQ   LANCTOESTOQ.NRLANCESTQ%TYPE;

   V_CDPRGENEREV  PRODUTO.CDPRODUTO%TYPE;
   V_NMPRGENEREV  PRODUTO.NMPRODUTO%TYPE;

   V_CDPRESTSERV  PRODUTO.CDPRODUTO%TYPE;
   V_NMPRESTSERV  PRODUTO.NMPRODUTO%TYPE;

   V_DSAJUCTREC   AJCTRECEBER.DSAJUSTEREC%TYPE;

   V_ENCARGO      ENCARGO.CDENCARGO%TYPE;

   V_CDTIPOOPER   TIPOOPERAC.CDTIPOOPER%TYPE;

   V_CDPROREECMP  PRODUTO.CDPRODUTO%TYPE;
   V_CDPRODDOTA   PRODUTO.CDPRODUTO%TYPE;
   V_CDPRODCREDI  PRODUTO.CDPRODUTO%TYPE;

   V_NVPRGENEREV  VARCHAR2(20);

   V_DSPRPRESERV  VARCHAR2(40);
   V_VERIGRUPDES  VARCHAR2(02);
   V_IDTAXAADM    VARCHAR2(01);
   V_IDCALCCOMPR  VARCHAR2(01);
   V_IDRECUIMPOS  VARCHAR2(01);
   V_IDCONCMPDES  VARCHAR2(01);
   V_IDAVISOCRED  VARCHAR2(01);
   V_DESCDOTACAO  VARCHAR2(01);
   V_CDAJUSTPADR  VARCHAR2(02);
   V_CDENCREDITO  VARCHAR2(02);
   V_CDENCDEBITO  VARCHAR2(02);
   V_IDPERCDOTA1  VARCHAR2(01);
   V_IDPERCDOTA2  VARCHAR2(01);
   V_IDPERCDOTA3  VARCHAR2(01);
   V_IDPERCDOTA4  VARCHAR2(01);
   V_IDPERCDOTA5  VARCHAR2(01);
   V_IDPERCDOTA6  VARCHAR2(01);

   V_VRBRUTITEM   NUMBER;
   V_VRIMPOSTOIT  NUMBER;
   V_VRBRUTDESP   NUMBER;
   V_VRTAXAADM    NUMBER;
   V_VRPCTXADM    NUMBER;
   V_VRLIQUFATU   NUMBER;
   V_PRXDESPESA   NUMBER;
   V_VRIMPODEBI   NUMBER;
   V_VRDEBITO     NUMBER;
   V_VRPERCDESP   NUMBER;
   V_VRDICMPCRE   NUMBER;
   V_VRIMPOITDESP NUMBER;
   V_VRIMTOITDESP NUMBER;
   V_VRTOTADESP   NUMBER;
   V_VRTOTACMP    NUMBER;
   V_VRLIQUIDO    NUMBER;
   V_VRSALDODEV   NUMBER;
   V_VRIMPCORPO   NUMBER;
   V_VRRECUIMCMP  NUMBER;
   V_VRRECUIMDES  NUMBER;
   V_VRRECUIMDET  NUMBER;
   V_VRSALDODOT   NUMBER;
   V_VRPERCDOT1   NUMBER;
   V_VRPERCDOT2   NUMBER;
   V_VRPERCDOT3   NUMBER;
   V_VRPERCDOT4   NUMBER;
   V_VRPERCDOT5   NUMBER;
   V_VRPERCDOT6   NUMBER;

   V_CDNIVELPROD  NUMBER;

   V_NRPRACMRDP   NUMBER;
   V_PRXMRDP      NUMBER;
   V_NUMITENS     NUMBER;

   V_IDNOVOMRDP   VARCHAR2(01);
   V_IDTXADMPROD  VARCHAR2(01);
   V_IDNFPRODREV  VARCHAR2(01);
   V_GERANF       VARCHAR2(01);
   V_LANCAMENTO   VARCHAR2(20);
   V_PAISORIG     VARCHAR2(04);
   V_ESTAORIG     VARCHAR2(02);
   V_MUNIORIG     VARCHAR2(04);
   V_PAISDEST     VARCHAR2(04);
   V_ESTADEST     VARCHAR2(02);
   V_IDENDCFOP    VARCHAR2(01);
   V_IDENDEMIS    VARCHAR2(01);
   V_IDGEROUNF    VARCHAR2(01);
   V_CDEMPRESA    VARCHAR2(02);
   V_CDINSCESTA   VARCHAR2(16);
   V_CDGRUPOFISC  VARCHAR2(03);

   V_NRSEQVENREC  CONTARECEBER.NRSEQVENREC%TYPE;
   V_NRPARCELAREC CONTARECEBER.NRPARCELAREC%TYPE;
   V_VRATUAREC    CONTARECEBER.VRATUAREC%TYPE;

   V_SERIE        SERIENF.CDSERIE%TYPE;
   V_CDSERIEDOT   SERIENF.CDSERIE%TYPE;

   V_INSCESTA     VARCHAR2(16);
   V_INSCMUNI     INSCRMUNICIP.CDINSCMUNI%TYPE;

   V_MAXITENSNF   NUMBER;
   V_NRITEM       NUMBER;
   V_SOMAALQIMP   NUMBER;
   V_VRCUSTOMED   NUMBER;
   V_VRALIQUTMP   NUMBER;
   V_VRICMS       NUMBER;

   V_VRTXADMPROD  NUMBER;
   V_TIPOOPER     VARCHAR2(02);
   V_VRFATOCONV   NUMBER;
   V_NMPRODUTO    VARCHAR2(50);
   V_CDPRODUTO    VARCHAR2(10);
   V_FILIAL       VARCHAR2(04);
   V_IDFATPRODCLI VARCHAR2(01);
   V_LANCTONF     NOTAFISCAL.NRLANCTONF%TYPE;
   V_DESCIT       NUMBER;
   V_QTDESCIT     NUMBER;
   V_VRSAIDA      NUMBER;
   V_VRIMPOSAID   NUMBER;
   V_VRTRANSF     NUMBER;
   V_VRIMPOTRANSF NUMBER;
   V_QTDESCIT1    NUMBER;
   V_VRTXFATNIV   NUMBER;
   V_VRDESCNFCMP  NUMBER;
   V_VRTOTCMPSTX  NUMBER;
   V_VRTOTCMPCTX  NUMBER;
   V_VRTOTDESCTX  NUMBER;
   V_VRTOTDESSTX  NUMBER;
   V_VRDOTPURPASS NUMBER;

   /*CURSOR AUXILIAR PARA DELETAR AS NOTAS FISCAIS*/
   CURSOR C_DELETANF IS SELECT CDFILIAL, NRLANCTONF
                        FROM NOTAFISCAL
                        WHERE CDFILIAL    = P_CDFILIPROC AND
                              NRAPURACFAT = P_NRAPURACFAT;

   CURSOR C_DESPADMFATUR IS  SELECT L.CDFILIAL, L.CDDESPADMFAT, L.DTLANCDESFAT,  L.VRLANCDESFAT,
                                    D.CDGRUPOFATUR, D.CDPRODUTO, D.DSDESPADMFAT, NVL(L.VRTXLANCDESP,0) VRTAXADMFATU
                             FROM LANCDESPFATU L,  DESPADMFATUR D
                             WHERE (L.CDFILIAL = P_CDFILIAPUR)                            AND
                                   (D.CDDESPADMFAT = L.CDDESPADMFAT)                      AND
                                   (L.DTLANCDESFAT BETWEEN P_DATAINI AND P_DATAFIM)
                             GROUP BY D.CDGRUPOFATUR, L.CDFILIAL, L.CDDESPADMFAT, L.DTLANCDESFAT, L.VRLANCDESFAT,
                                      D.CDPRODUTO, D.DSDESPADMFAT, VRTXLANCDESP;

   CURSOR C_NOTAFISCAL IS
      SELECT N.NRINSJURNF, N.NRNOTAFISC, N.CDFILIAL, N.NRLANCTONF, COUNT(*) AS NRITENSNOTA
      FROM NOTAFISCAL N, ITEMPRODUTO I
      WHERE N.CDFILIAL     = I.CDFILIAL    AND
            N.NRLANCTONF   = I.NRLANCTONF  AND
            N.CDFILIAPFATU = P_CDFILIPROC    AND
            N.NRAPFATUTNF  = P_NRAPURACFAT
      GROUP BY N.NRINSJURNF, N.NRNOTAFISC, N.CDFILIAL, N.NRLANCTONF;

   CURSOR C_ITEMNOTA IS
      SELECT I.CDPRODUTO, PT.CDPRODESTO,
             (NVL(SUM(I.VRBRUTITEM),0)/NVL(SUM(QTITEMPROD),1))  AS VRBRUTITEM,
             NVL(SUM(II.VRIMPOSTOIT),0) AS VRIMPOSTOIT,
             NVL(SUM(QTITEMPROD),1) AS QTITEMPROD,
             SUM(VRTAXADMFATU) VRTAXADMFATU
      FROM NOTAFISCAL N, ITEMPRODUTO I, ITEMPROIMPOS II,
           PRODFILI P,   PRODUTO PT,    TAXAADMFATUR TX,
           PRODUTO R
      WHERE (N.CDFILIAL         = I.CDFILIAL)            AND
            (N.NRLANCTONF       = I.NRLANCTONF)          AND
            (N.CDFILIAPFATU     = P_CDFILIPROC)          AND
            (N.NRAPFATUTNF      = P_NRAPURACFAT)         AND
            (II.CDFILIAL(+)     = I.CDFILIAL)            AND
            (II.NRLANCTONF(+)   = I.NRLANCTONF)          AND
            (II.NRSEQITPROD(+)  = I.NRSEQITPROD)         AND
            (II.CDIMPOSTO(+)    = V_CDIMPOSTO)           AND
            (II.NRITPROIMPOS(+) = '1')                   AND
            (I.CDPRODUTO        = PT.CDPRODUTO)          AND
            (PT.CDPRODESTO      = P.CDPRODUTO)           AND
            (N.CDFILIAPFATU     = P.CDFILIAL)            AND
            (R.CDPRODUTO(+)     = TX.CDPRODUTO)          AND
            (I.CDFILIAL(+)      = TX.CDFILIAL)           AND
            (INSTR(PT.CDARVPROD,NVL(R.CDARVPROD,'')) = 1)
      GROUP BY I.CDPRODUTO,   PT.CDPRODESTO

      UNION ALL

      SELECT I.CDPRODUTO, PT.CDPRODESTO,
             (NVL(SUM(I.VRBRUTITEM),0)/NVL(SUM(QTITEMPROD),1))  AS VRBRUTITEM,
             NVL(SUM(II.VRIMPOSTOIT),0) AS VRIMPOSTOIT,
             NVL(SUM(QTITEMPROD),1) AS QTITEMPROD,
             SUM(VRTAXADMFATU) VRTAXADMFATU
      FROM NOTAFISCAL N, ITEMPRODUTO I, ITEMPROIMPOS II,
           PRODFILI P,   PRODUTO PT,    TAXAADMFATUR TX,
           PRODUTO R
      WHERE (N.CDFILIAL         = I.CDFILIAL)          AND
            (N.NRLANCTONF       = I.NRLANCTONF)        AND
            (P_CDFILIPROC   IS NULL)                   AND
            (N.CDFILIAPFATU IS NULL)                   AND
            (P_NRAPURACFAT  IS NULL)                   AND
            (N.NRAPFATUTNF  IS NULL)                   AND
            (II.CDFILIAL(+)     = I.CDFILIAL)          AND
            (II.NRLANCTONF(+)   = I.NRLANCTONF)        AND
            (II.NRSEQITPROD(+)  = I.NRSEQITPROD)       AND
            (II.CDIMPOSTO(+)    = V_CDIMPOSTO)         AND
            (II.NRITPROIMPOS(+) = '1')                 AND
            (I.CDPRODUTO        = PT.CDPRODUTO)        AND
            (PT.CDPRODESTO      = P.CDPRODUTO)         AND
            (N.CDFILIAPFATU     = P.CDFILIAL)          AND
            (R.CDPRODUTO(+)     = TX.CDPRODUTO)        AND
            (I.CDFILIAL(+)      = TX.CDFILIAL)         AND
            (INSTR(PT.CDARVPROD,NVL(R.CDARVPROD,'')) = 1)
      GROUP BY I.CDPRODUTO,   PT.CDPRODESTO;

   CURSOR C_TIPOOPER IS
      SELECT N.CDTIPOOPER, N.CDFILIAL, N.NRLANCTONF
      FROM NOTAFISCAL N, ITEMPRODUTO I
      WHERE N.CDFILIAL        = I.CDFILIAL                      AND
           N.NRLANCTONF       = I.NRLANCTONF                    AND
           ((N.CDFILIAPFATU   = P_CDFILIPROC)                    OR
           (P_CDFILIPROC IS NULL AND N.CDFILIAPFATU IS NULL))   AND
           ((N.NRAPFATUTNF    =  P_NRAPURACFAT)                  OR
           (P_NRAPURACFAT IS NULL AND N.NRAPFATUTNF IS NULL))   AND
            I.CDPRODUTO       = V_CDPRODUTO;

BEGIN

   V_VRNOTAFISC   := 0;
   V_GERANF       := 'S';
   V_IDGEROUNF    := 'N';
   V_NRITEM       := 0;
   V_SOMAALQIMP   := 0;
   V_DESCIT       := 0;
   V_VRSAIDA      := 0;
   V_VRIMPOSAID   := 0;
   V_VRBRUTDESP   := 0;
   V_VRDEBITO     := 0;
   V_VRDICMPCRE   := 0;
   V_VRLIQUIDO    := 0;
   V_VRSALDODEV   := 0;
   V_VRTOTADESP   := 0;
   V_VRIMPCORPO   := 0;
   V_VRTXFATNIV   := 0;
   V_VRDESCNFCMP  := 0;
   V_VRRECUIMCMP  := 0;
   V_VRRECUIMDES  := 0;
   V_VRRECUIMDET  := 0;
   V_VRTOTACMP    := 0;
   V_VRTOTCMPSTX  := 0;
   V_VRTOTCMPCTX  := 0;
   V_VRSALDODOT   := 0;
   V_VRTOTDESSTX  := 0;
   V_VRTOTDESCTX  := 0;
   V_VRDOTPURPASS := 0;
   V_VRLIQUFATU   := 0;
   V_VRTOTCMPSTX  := 0;
   V_VRTOTCMPCTX  := 0;

   /* FILIAL QUE EST SENDO APURADA (P_FILIAL = FILIPROC)*/
   SELECT MAX(CDFILIAPUR), MAX(DTINIAPURAC)
   INTO V_CDFILIAPUR, V_DTINIAPURAC
   FROM CTRLAPURFAT
   WHERE CDFILIAL    = P_CDFILIPROC   AND
         NRAPURACFAT = P_NRAPURACFAT;

   SELECT MAX(DTINIAPURAC), MAX(DTFIMAPURAC)
   INTO  V_DTINIAPURAC, V_DTFIMAPURAC
   FROM CTRLAPURFAT
   WHERE CDFILIAL    = V_CDFILIAPUR   AND
         DTINIAPURAC < V_DTINIAPURAC;

   SELECT TO_NUMBER(NVL(MAX(SUBSTR(PF.DSPARAMFATFI,31,6)),0)),     /*PERCENTUAL DE COMPRAS/REVENDA*/
          MAX(SUBSTR(PF.DSPARAMFATFI,39,2)),                      /*EMPRESA ATACADISTA*/
          MAX(SUBSTR(PF.DSPARAMFATFI,41,2)),                     /*EMPRESA OPERACIONAL*/
          MAX(SUBSTR(PF.DSPARAMFATFI,43,1)),                    /*TAXA DE ADMINISTRACAO*/
          MAX(SUBSTR(PG.DSPARAMFATGE,22,40)),                  /*DESCRICAO PARA NOTA FISCAL*/
          RTRIM(MAX(SUBSTR(PG.DSPARAMFATGE,73,10))),          /*CODIGO DA PRODUTO PARA REVENDA*/
          RTRIM(MAX(SUBSTR(PG.DSPARAMFATGE,085,20))),        /* NVEL DOS PRODUTOS A SEREM GERADOS*/
          MAX(SUBSTR(PF.DSPARAMFATFI,49,1)),                /*CALCULO VALOR TOTAL DE COMPRAS*/
          MAX(SUBSTR(PF.DSPARAMFATFI,37,1)),               /*RECUPERAO DE IMPOSTOS*/
          MAX(SUBSTR(PF.DSPARAMFATFI,56,1)),              /*DESCONTO DE DOTAO*/
          MAX(SUBSTR(PF.DSPARAMFATFI,57,2)),             /*AJUSTE PADRAO*/
          MAX(SUBSTR(PF.DSPARAMFATFI,59,2)),            /*ENCARGO DEBITO*/
          MAX(SUBSTR(PF.DSPARAMFATFI,61,2)),           /*ENCARGO CREDITO*/
          TO_NUMBER(NVL(MAX(RTRIM(SUBSTR(PF.DSPARAMFATFI,63,6))),0)),      /*PERCENTUAL DE DESPESAS*/
          MAX(SUBSTR(PF.DSPARAMFATFI,69,1)),                              /*TAXA DE ADM POR PRODUTO*/
          MAX(SUBSTR(PG.DSPARAMFATGE,155,1)),                            /*GERA NF DE PRODUTO PARA REVENDA*/
          MAX(SUBSTR(PF.DSPARAMFATFI,70,2)),                            /*TIPO DE OPERACAO  */
          MAX(SUBSTR(PF.DSPARAMFATFI,72,1)),                           /*IDENTIFICADOR DE PARA DE NF DE DESPESA E COMPREAS CONSOLIDADA*/
          RTRIM(MAX(SUBSTR(PF.DSPARAMFATFI,73,10))),                         /*PRODUTO PARA REEMBOLSO DE COMPRAS*/
          RTRIM(MAX(SUBSTR(PF.DSPARAMFATFI,83,10))),                        /*PRODUTO PARA AVISO DE DEBITO (DOTACAO)*/
          RTRIM(MAX(SUBSTR(PF.DSPARAMFATFI,147,10))),                       /*PRODUTO PARA AVISO DE CREDITO*/
          MAX(SUBSTR(PF.DSPARAMFATFI,93,01)),                       /*IDENTIFICADOR PARA VERIFICAR A GERACAO DE AVISO OU NF DE CREDITO*/
          MAX(SUBSTR(PF.DSPARAMFATFI,96,01)),                      /*IDENTIFICADOR PARA CALCUL0 DA DOTAAO UM*/
          TO_NUMBER(NVL(MAX(REPLACE(SUBSTR(PF.DSPARAMFATFI,97,06),' ','')),0)),   /*PERCENTUAL PARA CALCUL0 DA DOTAAO UM*/
          MAX(SUBSTR(PF.DSPARAMFATFI,103,01)),                   /*IDENTIFICADOR PARA CALCUL0 DA DOTAAO DOIS*/
          TO_NUMBER(NVL(MAX(REPLACE(SUBSTR(PF.DSPARAMFATFI,104,06),' ','')),0)),/*PERCENTUAL PARA CALCUL0 DA DOTAAO DOIS*/
          MAX(SUBSTR(PF.DSPARAMFATFI,110,01)),                 /*IDENTIFICADOR PARA CALCUL0 DA DOTAAO TRES*/
          TO_NUMBER(NVL(MAX(REPLACE(SUBSTR(PF.DSPARAMFATFI,111,06),' ','')),0)),       /*PERCENTUAL PARA CALCUL0 DA DOTAAO TRES*/
          MAX(SUBSTR(PF.DSPARAMFATFI,117,01)),                        /*IDENTIFICADOR PARA CALCUL0 DA DOTAAO QUATRO*/
          TO_NUMBER(NVL(MAX(REPLACE(SUBSTR(PF.DSPARAMFATFI,118,06),' ','')),0)),     /*PERCENTUAL PARA CALCUL0 DA DOTAAO QUATRO*/
          MAX(SUBSTR(PF.DSPARAMFATFI,124,01)),                      /*IDENTIFICADOR PARA CALCUL0 DA DOTAAO CINCO*/
          TO_NUMBER(NVL(MAX(REPLACE(SUBSTR(PF.DSPARAMFATFI,125,06),' ','')),0)),   /*PERCENTUAL PARA CALCUL0 DA DOTAAO CINCO*/
          MAX(SUBSTR(PF.DSPARAMFATFI,131,01)),                    /*IDENTIFICADOR PARA CALCUL0 DA DOTAAO SEIS*/
          TO_NUMBER(NVL(MAX(REPLACE(SUBSTR(PF.DSPARAMFATFI,132,15),' ','')),0)), /*VALOR PARA CALCUL0 DA DOTAAO SEIS*/
          MAX(SUBSTR(PF.DSPARAMFATFI,157,05)),                  /*SRIE PARA GERAO DE AVISO DEBITO/CREDITO */
          RTRIM(MAX(SUBSTR(PG.DSPARAMFATGE,156,10)))                  /*PRODUTO PARA PRESTAO DE SERVIOS*/
   INTO V_VRPCTXADM,   V_CDEMPRATAC,  V_CDEMPROPER,  V_IDTAXAADM,
        V_DSPRPRESERV, V_CDPRGENEREV, V_NVPRGENEREV, V_IDCALCCOMPR,
        V_IDRECUIMPOS, V_DESCDOTACAO, V_CDAJUSTPADR, V_CDENCREDITO,
        V_CDENCDEBITO, V_VRPERCDESP,  V_IDTXADMPROD, V_IDNFPRODREV,
        V_CDTIPOOPER,  V_IDCONCMPDES, V_CDPROREECMP, V_CDPRODDOTA,
        V_CDPRODCREDI, V_IDAVISOCRED, V_IDPERCDOTA1, V_VRPERCDOT1,
        V_IDPERCDOTA2, V_VRPERCDOT2,  V_IDPERCDOTA3, V_VRPERCDOT3,
        V_IDPERCDOTA4, V_VRPERCDOT4,  V_IDPERCDOTA5, V_VRPERCDOT5,
        V_IDPERCDOTA6, V_VRPERCDOT6,  V_CDSERIEDOT,  V_CDPRESTSERV
   FROM PARAMFILIAL PF, PARAMGERAL PG
   WHERE PF.CDFILIAL = P_CDFILIAPUR;

   V_VRPCTXADM  := V_VRPCTXADM/1000;
   V_VRPERCDESP := V_VRPERCDESP/1000;

   V_VRPERCDOT1 := V_VRPERCDOT1/100;
   V_VRPERCDOT2 := V_VRPERCDOT2/100;
   V_VRPERCDOT3 := V_VRPERCDOT3/100;
   V_VRPERCDOT4 := V_VRPERCDOT4/100;
   V_VRPERCDOT5 := V_VRPERCDOT5/100;

   IF (V_CDTIPOOPER IS NULL) OR (V_CDTIPOOPER = '  ') THEN
      V_CDTIPOOPER := '01';
   END IF;

   IF V_IDCONCMPDES IS NULL THEN
      V_IDCONCMPDES := 'N';
   END IF;

   IF (V_CDPRODDOTA IS NULL) OR (V_CDPRODDOTA = '     ') THEN
      V_CDPRODDOTA := NULL;
   END IF;

   IF (V_CDAJUSTPADR IS NULL) OR (V_CDAJUSTPADR = '  ') THEN
      V_CDAJUSTPADR := NULL;
   END IF;

   SELECT MAX(NMPRODUTO)
   INTO V_NMPRGENEREV
   FROM PRODUTO
   WHERE CDPRODUTO  =  V_CDPRGENEREV;

   SELECT MAX(NMPRODUTO)
   INTO V_NMPRESTSERV
   FROM PRODUTO
   WHERE CDPRODUTO  =  V_CDPRESTSERV;
   
   SELECT LENGTH(MAX(CDARVPROD))
   INTO V_CDNIVELPROD
   FROM PRODUTO
   WHERE CDNVPRODUTO = '1';

   SELECT MAX(SUBSTR(DSAJUCTREC,1,20))
   INTO V_DSAJUCTREC
   FROM TIPOAJRECEBER
   WHERE V_CDAJUSTPADR = CDAJUCTREC;

   IF P_IDNFCOMPRA = 'N' THEN
      UPDATE  NOTAFISCAL
      SET CDFILIAPFATU = P_CDFILIPROC,
          NRAPFATUTNF  = P_NRAPURACFAT
      WHERE (CDEMPRESA    = V_CDEMPRATAC) AND
            (CDFILIRECE   = V_CDFILIAPUR) AND
            (DTENTRSAID BETWEEN  P_DTINIAPUR AND P_DTFINAPUR)    AND
            (IDENTRSAIDOP = 'E')          AND
            (IDSTATUS     <> 'C')         AND
            (NVL(IDSISTEMA,'DFE') IN ('DFE','EST')) AND
            ((NRAPFATUTNF IS NULL) OR (NRAPFATUTNF = P_NRAPURACFAT));
   END IF;

   /*VERIFICA SE EXISTE REGISTRO NA TABELA NOVOCODIGO P/ A SRIE DO MRDP*/
   SELECT TO_NUMBER(NVL(MAX(NRSEQUENCIAL),0))
   INTO V_PRXMRDP
   FROM NOVOCODIGO
   WHERE CDCONTADOR = 'LANCAMENTO DE MRDP';

   /*INCLUI CHAVE SEQUENCIAL PARA A SRIE DO MRDP*/
   IF V_PRXMRDP = 0 THEN
      INSERT INTO NOVOCODIGO
         (CDCONTADOR, NRSEQUENCIAL)
      VALUES
         ('LANCAMENTO DE MRDP', '00000000000000000001');

      V_PRXMRDP := 1;
   END IF;

   /*BLOQUEIA REGISTRO DA SRIE DO MRDP NA TABELA NOVOCODIGO*/
   SELECT TO_NUMBER(NRSEQUENCIAL) + 1
   INTO V_PRXMRDP
   FROM NOVOCODIGO
   WHERE CDCONTADOR = 'LANCAMENTO DE MRDP';

   /*INCLUSO DOS MRDP'S APURADOS CONSIDERANDO O NMERO MXIMO DE PRODUTOS MRDP*/

   FOR C_GERAMRDPAPUR IN C_NOTAFISCAL LOOP
        INSERT INTO MRDPAPUR
           (CDFILIAL, NRAPURACFAT, NRMRDPAPUR)
        VALUES
           (P_CDFILIPROC, P_NRAPURACFAT, LPAD(TO_CHAR(V_PRXMRDP),7,'0'));

        V_PRXMRDP := V_PRXMRDP + 1;

   END LOOP;

   /*ATUALIZAO DA TABELA NOVOCODIGO*/
   UPDATE NOVOCODIGO
   SET NRSEQUENCIAL = LPAD(TO_CHAR(V_PRXMRDP),20,'0')
   WHERE CDCONTADOR = 'LANCAMENTO DE MRDP';

   SELECT MAX(CDSERIE), MAX(CDINSCESTA), MAX(CDINSCMUNI)
   INTO V_SERIE, V_INSCESTA, V_INSCMUNI
   FROM FILIAL F
   WHERE F.CDFILIAL  = V_CDFILIAPUR   AND
         F.CDEMPRESA = V_CDEMPRATAC;

   SELECT MAX(CDSERIE), MAX(CDINSCESTA), MAX(CDINSCMUNI)
   INTO V_CDSERIE, V_CDINSCATAC, V_CDINSCMUNI
   FROM EMPRCNTRFIL F
   WHERE F.CDFILIAL  = V_CDFILIAPUR   AND
         F.CDEMPRESA = V_CDEMPRATAC;

   SELECT MAX(CDSERIE)
   INTO V_CDSERIEDESP
   FROM EMPRCNTRFIL F
   WHERE F.CDFILIAL  = V_CDFILIAPUR   AND
         F.CDEMPRESA = V_CDEMPROPER;

   IF  V_CDSERIE IS NULL THEN
      V_CDSERIE    := V_SERIE;
      V_CDINSCATAC := V_INSCESTA;
      V_CDINSCMUNI := V_INSCMUNI;
   END IF;

   IF V_CDSERIEDESP IS NULL THEN
      V_CDSERIE    := V_SERIE;
   END IF;

   /*VERIFICA A QTE MAXIMA DE PRODUTO POR SERIE*/
   SELECT NVL(MAX(NRMAXITNF),10)
   INTO V_MAXITENSNF
   FROM SERIENF
   WHERE CDEMPRESA  = V_CDEMPRATAC  AND
         CDINSCESTA = V_CDINSCATAC  AND
         CDINSCMUNI = V_CDINSCMUNI  AND
         CDSERIE    = V_CDSERIE;

   SELECT MAX(CDIMPOSTO)
   INTO V_CDIMPOSTO
   FROM IMPOSMRDP
   WHERE IDIMPOMRDP = 'P';

   IF P_VRBASENFCMP <> 0 THEN

      SELECT NVL(SUM(VRBRUTITEM),0), COUNT(IP.CDPRODUTO)
      INTO V_VRDESCNFCMP, V_NUMITENS
      FROM  ITEMPRODUTO IP, NOTAFISCAL N,  TAXAADMFATUR TX,
            PRODUTO P,		 PRODUTO R
      WHERE N.CDFILIAPFATU     = P_CDFILIPROC              AND
            N.NRAPFATUTNF      = P_NRAPURACFAT             AND
            IP.CDFILIAL        = N.CDFILIAL                AND
            IP.NRLANCTONF      = N.NRLANCTONF              AND
            P.CDPRODUTO        = IP.CDPRODUTO              AND
            R.CDPRODUTO        = TX.CDPRODUTO              AND
            IP.CDFILIAL        = TX.CDFILIAL               AND
            (INSTR(P.CDARVPROD,NVL(R.CDARVPROD,'')) = 1);

      IF V_VRDESCNFCMP <> 0 THEN
         V_VRDESCNFCMP := ((V_VRDESCNFCMP - P_VRBASENFCMP) / V_NUMITENS);
      END IF;
   END IF;

   FOR C_TAXA IN (SELECT IP.CDFILIAL, IP.CDPRODUTO, VRBRUTITEM, R.CDARVPROD
                  FROM  ITEMPRODUTO IP, NOTAFISCAL N,  TAXAADMFATUR TX,
                  		PRODUTO P, PRODUTO R
                  WHERE N.CDFILIAPFATU     = P_CDFILIPROC              AND
                        N.NRAPFATUTNF      = P_NRAPURACFAT             AND
                        IP.CDFILIAL        = N.CDFILIAL                AND
                        IP.NRLANCTONF      = N.NRLANCTONF              AND
                        N.CDTIPOOPER       <> '12'                     AND
                        P.CDPRODUTO        = IP.CDPRODUTO              AND
                        R.CDPRODUTO        = TX.CDPRODUTO              AND
                        IP.CDFILIAL        = TX.CDFILIAL               AND
                        (INSTR(P.CDARVPROD,NVL(R.CDARVPROD,'')) = 1)
                   ORDER BY 2) LOOP

      SELECT MAX(IDFATPRODCLI)
      INTO V_IDFATPRODCLI
      FROM PRODFILIFATU
      WHERE (CDFILIAL      = C_TAXA.CDFILIAL)               AND
            (INSTR(C_TAXA.CDPRODUTO,NVL(CDPRODUTO,'')) = 1) AND
            (CDTPFATPRFIL  = '003');

      V_VRBRUTITEM := (C_TAXA.VRBRUTITEM - V_VRDESCNFCMP);

      SELECT NVL(MAX(VRTAXADMFATU),0)
      INTO V_VRTXFATNIV
      FROM TAXAADMFATUR TX, PRODUTO P
      WHERE (TX.CDFILIAL  = C_TAXA.CDFILIAL) AND
            (TX.CDPRODUTO = P.CDPRODUTO)     AND
            (INSTR(C_TAXA.CDARVPROD,NVL(P.CDARVPROD,'')) = 1);

      IF V_VRTXFATNIV <> 0 THEN
          V_VRTAXAADM := ((V_VRBRUTITEM) * (V_VRTXFATNIV / 100));
      ELSE
          V_VRTAXAADM := (V_VRBRUTITEM * (V_VRPCTXADM / 100));
      END IF;

      IF  (V_IDFATPRODCLI  = '1') OR (V_IDFATPRODCLI IS NULL) THEN
         IF V_IDCALCCOMPR = '1' THEN
            V_VRLIQUFATU := V_VRLIQUFATU  + ((V_VRBRUTITEM + NVL(V_VRTAXAADM,0)));
         ELSE
            V_VRLIQUFATU :=  V_VRLIQUFATU + (NVL(V_VRTAXAADM,0));
         END IF;
         V_VRTOTCMPSTX   := (V_VRTOTCMPSTX + V_VRBRUTITEM);
         V_VRTOTCMPCTX   := (V_VRTOTCMPCTX + V_VRTAXAADM);
      ELSIF (V_IDFATPRODCLI  = '2') THEN
          /*V_VRLIQUFATU   := (V_VRLIQUFATU + V_VRBRUTITEM); */
          V_VRTOTCMPSTX  := (V_VRTOTCMPSTX + V_VRBRUTITEM);
      END IF;
   END LOOP;

   V_NRLANCTONF := P_NRLANCTONF;
   V_NRLANCCMP  := P_NRLANCTONF;
   V_LANCAMENTO := P_NRLANCTONF;

  FOR C_NOTAFISCAL IN C_DELETANF LOOP
      DELETA_NF(C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.NRLANCTONF);
   END LOOP;
   IF NOT (NVL(V_IDNFPRODREV,'N') = 'S') THEN

      IF V_VRLIQUFATU > 0 THEN

         IF V_IDRECUIMPOS = 'S' THEN

            /*VARIVEIS PARA CONSULTA DE ALQUOTA*/

            SELECT MAX(NVL(IDENDCFOPFIL,'I')),
                   MAX(CDEMPRESA), MAX(CDINSCESTA)
            INTO V_IDENDCFOP, V_CDEMPRESA, V_CDINSCESTA
            FROM FILIAL
            WHERE (CDFILIAL = P_CDFILIAPUR);

            IF V_IDENDCFOP = 'I' THEN
               SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
               INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
               FROM INSCRESTAD
               WHERE CDEMPRESA  = V_CDEMPRESA AND
                     CDINSCESTA = V_CDINSCESTA;
            ELSE
               SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
               INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
               FROM ENDEFILI
               WHERE (CDFILIAL     = P_CDFILIAPUR) AND
                     (IDTPENDEFILI = V_IDENDCFOP);
            END IF;

            SELECT NVL(MAX(IDENDCFOPCLI),'P'), NVL(MAX(IDENDEMISCLI),'P')
            INTO V_IDENDCFOP, V_IDENDEMIS
            FROM CLIENTE
            WHERE (CDCLIENTE = P_CDCLIENTE);

            SELECT MAX(CDPAIS), MAX(SGESTADO)
            INTO V_PAISDEST, V_ESTADEST
            FROM ENDECLIE
            WHERE (CDCLIENTE    = P_CDCLIENTE) AND
                  (IDTPENDECLIE = V_IDENDEMIS);

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

            CONSULTA_GRUPOFISCAL('C', P_CDCLIENTE , V_CDFILIAPUR, 'S', V_CDTIPOOPER, V_CDGRUPOFISC);

            /*CALCULO DA ALIQUOTA IMPOSTO*/

            /* ISS */

            CONSULTA_ALIQUOTA('31', 'S',  V_CDEMPRATAC, V_CDPRGENEREV,  V_CDINSCATAC, V_PAISORIG,
                              V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, V_VRLIQUFATU, P_DATAFIM,
                              P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

            SELECT NVL(MAX(VRALIQUTMP),0)
            INTO V_VRALIQUTMP
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

            V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

            /* PIS */

            CONSULTA_ALIQUOTA('50', 'S',  V_CDEMPRATAC, V_CDPRGENEREV,  V_CDINSCATAC, V_PAISORIG,
                              V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, V_VRLIQUFATU, P_DATAFIM,
                              P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

            SELECT NVL(MAX(VRALIQUTMP),0)
            INTO V_VRALIQUTMP
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

            V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

             /* COFINS */

            CONSULTA_ALIQUOTA('60', 'S',  V_CDEMPRATAC, V_CDPRGENEREV, V_CDINSCATAC, V_PAISORIG,
                               V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, V_VRLIQUFATU, P_DATAFIM,
                               P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

            SELECT NVL(MAX(VRALIQUTMP),0)
            INTO V_VRALIQUTMP
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

            V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

            IF V_SOMAALQIMP <>  0 THEN
                IF V_IDTAXAADM = 'D' THEN  /*POR DENTRO*/
                    V_VRRECUIMCMP := (V_SOMAALQIMP / 100);
                ELSE                       /*POR FORA*/
                    V_VRRECUIMCMP := (100 / (100 - V_SOMAALQIMP));
                END IF;
            END IF;

         V_VRLIQUFATU := (V_VRLIQUFATU * V_VRRECUIMCMP);

         END IF;

        /*INCLUSO DO CORPO DA NOTA */
         GERA_NOTAFISCAL_CORPO(P_CDFILIPROC, V_CDFILIAPUR, V_CDEMPRATAC, V_CDTIPOOPER,
                               V_CDSERIE, P_CDCLIENTE, P_DATAFIM, 'FAI',
                               V_NRLANCTONF, V_NRLANCESTQ, 'N', P_NRAPURACFAT,
                               V_NRLANCTONF, NULL, NULL, NULL, NULL, NULL, NULL,
                               NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                               P_DATAFIM, NULL);

         /*INCLUSO DOS ITENS DA NOTA FISCAL*/
         GERA_NOTAFISCAL_PRODUTO(P_CDFILIPROC, V_NRLANCTONF, V_CDPRGENEREV,
                                 V_CDPRGENEREV, V_NMPRGENEREV, 1, V_VRLIQUFATU, 0,
                                 NULL, NULL, NULL, NULL,
                                 NULL, NULL);

         /*EFETUA O FECHAMENTO DA NOTA, GERACAO DE IMPOSTOS*/
         GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_NRLANCTONF);

         V_IDGEROUNF  := 'S';

         V_VRTOTACMP  := V_VRLIQUFATU;

      END IF;
   ELSE

      FOR C_GERANFREVEN IN C_ITEMNOTA LOOP

         V_SOMAALQIMP := 0;
         V_DESCIT     := 0;

         SELECT MAX(P.VRTXADMPROD),
                MAX(PT.VRFATOCONV), MAX(NMPRODUTO)
         INTO V_VRTXADMPROD, V_VRFATOCONV, V_NMPRODUTO
         FROM NOTAFISCAL N, ITEMPRODUTO I,
              PRODUTO PT,   PRODFILI P
         WHERE N.CDFILIAL         = I.CDFILIAL                         AND
               N.NRLANCTONF       = I.NRLANCTONF                       AND
               ((N.CDFILIAPFATU   = P_CDFILIPROC)                      OR
                (P_CDFILIPROC IS NULL AND N.CDFILIAPFATU IS NULL))     AND
               ((N.NRAPFATUTNF    =  P_NRAPURACFAT)                    OR
                (P_NRAPURACFAT IS NULL AND N.NRAPFATUTNF IS NULL))     AND
               I.CDPRODUTO        = PT.CDPRODUTO                       AND
               I.CDPRODUTO        = C_GERANFREVEN.CDPRODUTO            AND
               PT.CDPRODESTO      = P.CDPRODUTO                        AND
               N.CDFILIAPFATU     = P.CDFILIAL
         GROUP BY P.VRTXADMPROD, PT.VRFATOCONV, NMPRODUTO;

         IF C_GERANFREVEN.VRBRUTITEM > 0 THEN

         /*VARIVEIS PARA CONSULTA DE ALQUOTA*/

            SELECT MAX(NVL(IDENDCFOPFIL,'I')),
                   MAX(CDEMPRESA), MAX(CDINSCESTA)
            INTO V_IDENDCFOP, V_CDEMPRESA, V_CDINSCESTA
            FROM FILIAL
            WHERE (CDFILIAL = P_CDFILIAPUR);

            IF V_IDENDCFOP = 'I' THEN
               SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
               INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
               FROM INSCRESTAD
               WHERE CDEMPRESA  = V_CDEMPRESA AND
                     CDINSCESTA = V_CDINSCESTA;
            ELSE
               SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
               INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
               FROM ENDEFILI
               WHERE (CDFILIAL     = P_CDFILIAPUR) AND
                     (IDTPENDEFILI = V_IDENDCFOP);
            END IF;

            SELECT NVL(MAX(IDENDCFOPCLI),'P'), NVL(MAX(IDENDEMISCLI),'P')
            INTO V_IDENDCFOP, V_IDENDEMIS
            FROM CLIENTE
            WHERE (CDCLIENTE = P_CDCLIENTE);

            SELECT MAX(CDPAIS), MAX(SGESTADO)
            INTO V_PAISDEST, V_ESTADEST
            FROM ENDECLIE
            WHERE (CDCLIENTE    = P_CDCLIENTE) AND
                  (IDTPENDECLIE = V_IDENDEMIS);

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

            CONSULTA_GRUPOFISCAL('C', P_CDCLIENTE , V_CDFILIAPUR, 'S', V_CDTIPOOPER, V_CDGRUPOFISC);

            /*CALCULO DA ALIQUOTA IMPOSTO*/

            CONSULTA_ALIQUOTA('80', 'S',  V_CDEMPRATAC, C_GERANFREVEN.CDPRODUTO,  V_CDINSCATAC, V_PAISORIG,
                              V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, C_GERANFREVEN.VRBRUTITEM, P_DATAFIM,
                              P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

            SELECT NVL(MAX(VRALIQUTMP),0)
            INTO V_VRALIQUTMP
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

            V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

            CONSULTA_ALIQUOTA('50', 'S',  V_CDEMPRATAC, C_GERANFREVEN.CDPRODUTO,  V_CDINSCATAC, V_PAISORIG,
                              V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, C_GERANFREVEN.VRBRUTITEM, P_DATAFIM,
                              P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

           SELECT NVL(MAX(VRALIQUTMP),0)
           INTO V_VRALIQUTMP
           FROM ALIQTEMP
           WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

           V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

           DELETE ALIQTEMP
           WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

           CONSULTA_ALIQUOTA('60', 'S',  V_CDEMPRATAC, C_GERANFREVEN.CDPRODUTO, V_CDINSCATAC, V_PAISORIG,
                              V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, C_GERANFREVEN.VRBRUTITEM, P_DATAFIM,
                              P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

           SELECT NVL(MAX(VRALIQUTMP),0)
           INTO V_VRALIQUTMP
           FROM ALIQTEMP
           WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

           V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

           DELETE ALIQTEMP
           WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

           V_TIPOOPER  := '';
           V_CDPRODUTO := C_GERANFREVEN.CDPRODUTO;

           FOR C_OPERACAO IN C_TIPOOPER LOOP
              IF C_OPERACAO.CDTIPOOPER = '02' THEN
                 V_TIPOOPER := '02';
              END IF;

              SELECT NVL(SUM(QTITEMPROD),0) AS QTDESCIT
              INTO V_QTDESCIT
              FROM ITEMNOTAFISC IT, NOTAFISCAL T, ITEMPRODUTO IP
              WHERE (IT.CDFILIALIT   = C_OPERACAO.CDFILIAL)               AND
                    (IT.NRLANCTONFIT = C_OPERACAO.NRLANCTONF)             AND
                    (T.CDFILIAL      = IT.CDFILIAL)                       AND
                    (T.NRLANCTONF    = IT.NRLANCTONF)                     AND
                    (IP.CDPRODUTO    = C_GERANFREVEN.CDPRODUTO)           AND
                    (IP.CDFILIAL     = T.CDFILIAL)                        AND
                    (IP.NRLANCTONF   = T.NRLANCTONF)                      AND
                    (IDSTATUS     <> 'C');
              V_DESCIT  := V_DESCIT + V_QTDESCIT;

              SELECT NVL(SUM(IP.QTITEMPROD),0) AS QTDESCIT1
              INTO V_QTDESCIT1
              FROM NOTAFISCAL N, ITEMPRODUTO IP
              WHERE
                 (N.CDFILIEMIT   = P_CDFILIAPUR)               AND
                 (N.CDFILIAL     = IP.CDFILIAL)                AND
                 (N.NRLANCTONF   = IP.NRLANCTONF)              AND
                 (IP.CDPRODUTO   = C_GERANFREVEN.CDPRODUTO)    AND
                 (N.IDSTATUS     <> 'C')                       AND
                 (N.CDTIPOOPER   IN ('02','09'))               AND
                 (N.IDENTRSAIDOP = 'S')                        AND
                 (N.DTENTRSAID BETWEEN P_DATAINI AND P_DATAFIM);

              V_DESCIT := V_DESCIT + V_QTDESCIT1;

           END LOOP;

           IF NOT V_TIPOOPER = '02' THEN

               CONSULTA_ALIQUOTA('00', 'E',  V_CDEMPRATAC, C_GERANFREVEN.CDPRODUTO, V_CDINSCATAC, V_PAISORIG,
                                 V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, C_GERANFREVEN.VRBRUTITEM, P_DATAFIM,
                                 P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

               SELECT NVL(MAX(VRALIQUTMP),0)
               INTO V_VRALIQUTMP
               FROM ALIQTEMP
               WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);
               V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

               DELETE ALIQTEMP
               WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

           END IF;

           V_VRCUSTOMED  := CUSTO_PRODUTO(P_CDFILIAPUR, C_GERANFREVEN.CDPRODESTO, 3, P_DATAFIM, P_DATAPROC);

           IF V_IDRECUIMPOS = 'S' THEN
              IF V_VRCUSTOMED > 0 THEN
                 V_VRCUSTOMED := V_VRFATOCONV * (V_VRCUSTOMED/(1- (V_SOMAALQIMP/100)));
              ELSE
                 V_VRCUSTOMED := (C_GERANFREVEN.VRBRUTITEM/(1- (V_SOMAALQIMP/100)));
              END IF;
           END IF;

           IF V_GERANF = 'S' THEN
              /*INCLUSO DO CORPO DA NOTA*/
              GERA_NOTAFISCAL_CORPO(P_CDFILIPROC, V_CDFILIAPUR, V_CDEMPRATAC, V_CDTIPOOPER,
                                    V_CDSERIE, P_CDCLIENTE, P_DATAFIM, 'FAI',
                                    V_LANCAMENTO, V_NRLANCESTQ, 'N', P_NRAPURACFAT,
                                    V_LANCAMENTO, NULL, NULL, NULL, NULL, NULL, NULL,
                                    NULL, NULL, NULL,   NULL, NULL, NULL, NULL,
                                    P_DATAFIM, NULL);

              V_GERANF := 'N';
           END IF;

           IF V_IDTXADMPROD = 'S' THEN
              IF V_IDTAXAADM = '1' THEN  /*POR DENTRO*/
                    V_VRTAXAADM := (V_VRCUSTOMED/ (1 - (V_VRTXADMPROD / 100))) - V_VRCUSTOMED;
              ELSE                       /*POR FORA*/
                 V_VRTAXAADM := (V_VRCUSTOMED * (V_VRTXADMPROD/ 100));
              END IF;

           ELSE
              IF V_IDTAXAADM = '1' THEN  /*POR DENTRO*/
                 V_VRTAXAADM := (V_VRCUSTOMED/ (1 - (V_VRPCTXADM/ 100))) - V_VRCUSTOMED;
              ELSE                       /*POR FORA*/
                 V_VRTAXAADM := (V_VRCUSTOMED * (V_VRPCTXADM/ 100));
              END IF;

           END IF;

           IF V_IDCALCCOMPR = '1' THEN
              V_VRLIQUFATU := (V_VRCUSTOMED + NVL(V_VRTAXAADM,0));
           ELSE
              V_VRLIQUFATU :=  NVL(V_VRTAXAADM,0) ;
           END IF;

           IF V_MAXITENSNF > V_NRITEM THEN
            /*INCLUSO DOS ITENS DA NOTA FISCAL*/

             GERA_NOTAFISCAL_PRODUTO(P_CDFILIPROC, V_LANCAMENTO, C_GERANFREVEN.CDPRODUTO,
                                     C_GERANFREVEN.CDPRODUTO, V_NMPRODUTO, (C_GERANFREVEN.QTITEMPROD - V_DESCIT), V_VRLIQUFATU, 0,
                                     NULL, NULL, NULL, NULL,
                                     NULL, NULL);

           /*EFETUA O FECHAMENTO DA NOTA, GERACAO DE IMPOSTOS*/
             GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_LANCAMENTO);
             V_VRTOTACMP := V_VRTOTACMP + ((C_GERANFREVEN.QTITEMPROD - V_DESCIT) *  V_VRLIQUFATU);
             V_NRITEM := V_NRITEM + 1;
           ELSE

              NOVO_CODIGO('LANCNF/FILIAL' || P_CDFILIAPUR,V_LANCAMENTO);
              V_LANCAMENTO := SUBSTR(V_LANCAMENTO,11,10);

              GERA_NOTAFISCAL_CORPO(P_CDFILIPROC, V_CDFILIAPUR, V_CDEMPRATAC, V_CDTIPOOPER,
                                    V_CDSERIE, P_CDCLIENTE, P_DATAFIM, 'FAI',
                                    V_LANCAMENTO, V_NRLANCESTQ, 'N', P_NRAPURACFAT,
                                    V_LANCAMENTO,NULL, NULL, NULL, NULL, NULL, NULL,
                                    NULL, NULL,  NULL,  NULL, NULL, NULL, NULL,
                                    P_DATAFIM, NULL);

             /*INCLUSO DOS ITENS DA NOTA FISCAL*/
             GERA_NOTAFISCAL_PRODUTO(P_CDFILIPROC, V_LANCAMENTO, C_GERANFREVEN.CDPRODUTO,
                                     C_GERANFREVEN.CDPRODUTO, V_NMPRODUTO, (C_GERANFREVEN.QTITEMPROD - V_DESCIT), V_VRLIQUFATU, 0,
                                     NULL, NULL, NULL, NULL,
                                     NULL, NULL);

           /*EFETUA O FECHAMENTO DA NOTA, GERACAO DE IMPOSTOS*/
             GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_LANCAMENTO);
             V_VRTOTACMP := V_VRTOTACMP + ((C_GERANFREVEN.QTITEMPROD - V_DESCIT) *  V_VRLIQUFATU);
             V_NRITEM := 0;
           END IF;
         END IF;
      END LOOP;
   END IF;
   /*INCLUSO DO ITENS DA DESPESA ADMINISTRATIVAS LANADAS NO FAI*/
   V_VERIGRUPDES := 'X';


   IF V_NMPRESTSERV IS NULL THEN
      FOR C_DESPESA IN C_DESPADMFATUR LOOP

         IF (LTRIM(V_CDFILIAPUR) IS NULL) THEN

            INSERT INTO CTRLAPURFAT
               (CDFILIAL, NRAPURACFAT,  CDFILIAPUR, CDCLIENTE, DTINIAPURAC, DTFIMAPURAC, CDTIPOFATUCT)
            VALUES
               (P_CDFILIPROC, P_NRAPURACFAT, P_CDFILIAPUR, P_CDCLIENTE, P_DATAINI, P_DATAFIM, '003');

         END IF;

         IF V_VERIGRUPDES <> C_DESPESA.CDGRUPOFATUR THEN

            IF (V_VERIGRUPDES <> 'X' AND V_VRTOTADESP > 0) THEN
              /*EFETUA O FECHAMENTO DA NOTA, GERACAO DE IMPOSTOS*/
              GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_NRLANCTONF);
            END IF;

            IF V_IDCONCMPDES = 'S'  THEN
               V_NRLANCTONF := LPAD(TO_CHAR((TO_NUMBER(V_NRLANCTONF) + 1)),10,'0');

              /*INCLUSO DO CORPO DA NOTA */
              GERA_NOTAFISCAL_CORPO(P_CDFILIPROC, P_CDFILIAPUR, V_CDEMPROPER, V_CDTIPOOPER,
                                    NVL(V_CDSERIEDESP,V_CDSERIE), P_CDCLIENTE, P_DATAFIM, 'FAI',
                                    V_NRLANCTONF, V_NRLANCESTQ, 'N', P_NRAPURACFAT,
                                    V_NRLANCTONF,NULL, NULL, NULL, NULL, NULL, NULL,
                                    NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                                    P_DATAFIM, NULL);

            END IF;
         END IF;

         V_VERIGRUPDES := C_DESPESA.CDGRUPOFATUR;

         V_VRTOTDESSTX := (V_VRTOTDESSTX + C_DESPESA.VRLANCDESFAT);

         IF C_DESPESA.VRTAXADMFATU <> 0  THEN
            V_VRTAXAADM := (C_DESPESA.VRLANCDESFAT * (C_DESPESA.VRTAXADMFATU / 100));
         ELSE
            V_VRTAXAADM := (C_DESPESA.VRLANCDESFAT * (V_VRPERCDESP / 100));
         END IF;

         SELECT MAX(IDFATPRODCLI)
         INTO V_IDFATPRODCLI
         FROM PRODFILIFATU
         WHERE (CDFILIAL      = C_DESPESA.CDFILIAL)                AND
               (INSTR(C_DESPESA.CDPRODUTO,NVL(CDPRODUTO,'')) = 1)  AND
               (CDTPFATPRFIL  = '003');

         IF  (V_IDFATPRODCLI  = '1') OR (V_IDFATPRODCLI IS NULL) THEN
            V_VRLIQUFATU  := (C_DESPESA.VRLANCDESFAT + NVL(V_VRTAXAADM,0));
            V_VRTOTDESCTX := (V_VRTOTDESCTX + NVL(V_VRTAXAADM,0));
         ELSIF (V_IDFATPRODCLI  = '2') THEN
            V_VRLIQUFATU  := (C_DESPESA.VRLANCDESFAT);
         END IF;

         IF V_IDRECUIMPOS = 'S' THEN

            V_SOMAALQIMP  := 0;

            IF V_IDGEROUNF = 'S' THEN

               /*VARIVEIS PARA CONSULTA DE ALQUOTA*/

               SELECT MAX(NVL(IDENDCFOPFIL,'I')),
                      MAX(CDEMPRESA), MAX(CDINSCESTA)
               INTO V_IDENDCFOP, V_CDEMPRESA, V_CDINSCESTA
               FROM FILIAL
               WHERE (CDFILIAL = P_CDFILIAPUR);

               IF V_IDENDCFOP = 'I' THEN
                  SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
                  INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
                  FROM INSCRESTAD
                  WHERE CDEMPRESA  = V_CDEMPRESA AND
                        CDINSCESTA = V_CDINSCESTA;
               ELSE
                  SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
                  INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
                  FROM ENDEFILI
                  WHERE (CDFILIAL     = P_CDFILIAPUR) AND
                        (IDTPENDEFILI = V_IDENDCFOP);
               END IF;

               SELECT NVL(MAX(IDENDCFOPCLI),'P'), NVL(MAX(IDENDEMISCLI),'P')
               INTO V_IDENDCFOP, V_IDENDEMIS
               FROM CLIENTE
               WHERE (CDCLIENTE = P_CDCLIENTE);

               SELECT MAX(CDPAIS), MAX(SGESTADO)
               INTO V_PAISDEST, V_ESTADEST
               FROM ENDECLIE
               WHERE (CDCLIENTE    = P_CDCLIENTE) AND
                     (IDTPENDECLIE = V_IDENDEMIS);

            END IF;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

            CONSULTA_GRUPOFISCAL('C', P_CDCLIENTE , V_CDFILIAPUR, 'S', V_CDTIPOOPER, V_CDGRUPOFISC);

            /*CALCULO DA ALIQUOTA IMPOSTO*/

            /* ISS */

            CONSULTA_ALIQUOTA('31', 'S',  V_CDEMPRATAC, C_DESPESA.CDPRODUTO,  V_CDINSCATAC, V_PAISORIG,
                                 V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG,V_VRLIQUFATU, P_DATAFIM,
                                 P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

            SELECT NVL(MAX(VRALIQUTMP),0)
            INTO V_VRALIQUTMP
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

            V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

            /* PIS */

            CONSULTA_ALIQUOTA('50', 'S',  V_CDEMPRATAC, C_DESPESA.CDPRODUTO,  V_CDINSCATAC, V_PAISORIG,
                              V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, V_VRLIQUFATU, P_DATAFIM,
                              P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

            SELECT NVL(MAX(VRALIQUTMP),0)
            INTO V_VRALIQUTMP
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

            V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

            /* COFINS */

            CONSULTA_ALIQUOTA('60', 'S',  V_CDEMPRATAC,C_DESPESA.CDPRODUTO, V_CDINSCATAC, V_PAISORIG,
                              V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, V_VRLIQUFATU, P_DATAFIM,
                              P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

            SELECT NVL(MAX(VRALIQUTMP),0)
            INTO V_VRALIQUTMP
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

            V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

            IF V_SOMAALQIMP <>  0 THEN
               IF V_IDTAXAADM = 'D' THEN  /*POR DENTRO*/
                    V_VRRECUIMDES := (V_SOMAALQIMP / 100);
               ELSE                       /*POR FORA*/
                    V_VRRECUIMDES := (100 / (100 - V_SOMAALQIMP));
               END IF;
            END IF;
            V_VRLIQUFATU := (V_VRLIQUFATU * V_VRRECUIMDES);
         END IF;

         /*INCLUSO DOS ITENS DA NOTA FISCAL*/
         IF V_VRLIQUFATU > 0 THEN

            GERA_NOTAFISCAL_PRODUTO(P_CDFILIPROC, V_NRLANCTONF, C_DESPESA.CDPRODUTO,
                                    C_DESPESA.CDDESPADMFAT, C_DESPESA.DSDESPADMFAT, 1, V_VRLIQUFATU, 0,
                                    NULL, NULL, NULL, NULL,
                                    NULL, NULL);

            UPDATE LANCDESPFATU
            SET CDFILILANC = P_CDFILIPROC,
                NRLANCTONF = V_NRLANCTONF
            WHERE (CDFILIAL = P_CDFILIAPUR)                        AND
                  (CDDESPADMFAT = C_DESPESA.CDDESPADMFAT)          AND
                  (DTLANCDESFAT BETWEEN P_DATAINI AND P_DATAFIM);


            V_VRTOTADESP := (V_VRTOTADESP + V_VRLIQUFATU);
         END IF;

      END LOOP;

      IF V_VERIGRUPDES  <> 'X' AND V_VRTOTADESP > 0 THEN
          GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_NRLANCTONF);
      END IF;

   ELSE
      IF V_IDCONCMPDES = 'S'  THEN
         IF (LTRIM(V_CDFILIAPUR) IS NULL) THEN

            INSERT INTO CTRLAPURFAT
               (CDFILIAL, NRAPURACFAT,  CDFILIAPUR, CDCLIENTE, DTINIAPURAC, DTFIMAPURAC, CDTIPOFATUCT)
            VALUES
               (P_CDFILIPROC, P_NRAPURACFAT, P_CDFILIAPUR, P_CDCLIENTE, P_DATAINI, P_DATAFIM, '003');

         END IF;



         V_NRLANCTONF := LPAD(TO_CHAR((TO_NUMBER(V_NRLANCTONF) + 1)),10,'0');

         /*INCLUSO DO CORPO DA NOTA */
         GERA_NOTAFISCAL_CORPO(P_CDFILIPROC, P_CDFILIAPUR, V_CDEMPROPER, V_CDTIPOOPER,
                               V_CDSERIEDESP, P_CDCLIENTE, P_DATAFIM, 'FAI',
                               V_NRLANCTONF, V_NRLANCESTQ, 'N', P_NRAPURACFAT,
                               V_NRLANCTONF,NULL, NULL, NULL, NULL, NULL, NULL,
                               NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                               P_DATAPROC, NULL);

         IF V_IDTAXAADM = 'D' THEN  /*POR DENTRO*/
            V_VRTAXAADM := (V_VRTOTACMP / (1 - (V_VRPERCDESP / 100))) - (V_VRTOTACMP);
         ELSE                       /*POR FORA*/
            V_VRTAXAADM := (V_VRTOTACMP * (V_VRPERCDESP / 100));
         END IF;

         V_VRLIQUFATU := NVL(V_VRTAXAADM,0);

         GERA_NOTAFISCAL_PRODUTO(P_CDFILIPROC, V_NRLANCTONF, V_CDPRESTSERV, V_CDPRESTSERV, V_NMPRESTSERV,
                              1, V_VRLIQUFATU, 0, NULL, NULL, NULL, NULL, NULL, NULL);

         GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_NRLANCTONF);
      END IF;
   END IF;

   IF (NOT V_IDNFPRODREV = 'S') AND (V_IDGEROUNF = 'S')  THEN

      /* Gerao do Aviso de Dbito */

      V_VRSALDODOT := 0;

      IF V_IDPERCDOTA1 = 'S' THEN
         V_VRSALDODOT := V_VRSALDODOT + ((V_VRTOTCMPSTX + V_VRTOTACMP + V_VRTOTADESP) * (V_VRPERCDOT1 / 100));
      END IF;

      IF V_IDPERCDOTA2 = 'S' THEN
         V_VRSALDODOT := V_VRSALDODOT + ((V_VRTOTDESSTX * (V_VRPERCDOT2 / 100)) + ((V_VRTOTDESCTX + V_VRTOTCMPCTX) * (V_VRPERCDOT2 / 100)));
      END IF;

     IF V_IDPERCDOTA3  = 'S' THEN
         V_VRSALDODOT := V_VRSALDODOT + ((V_VRTOTDESSTX + (V_VRTOTDESCTX + V_VRTOTCMPCTX)) * (V_VRPERCDOT3 / 100));
      END IF;

      IF V_IDPERCDOTA4 = 'S' THEN
         V_VRSALDODOT := V_VRSALDODOT + ((V_VRTOTCMPSTX + V_VRTOTACMP) * (V_VRPERCDOT4 / 100));
      END IF;

      IF V_IDPERCDOTA5 = 'S' THEN
         V_VRSALDODOT := V_VRSALDODOT + ((V_VRTOTDESSTX + V_VRTOTDESCTX) + ((V_VRTOTDESSTX + V_VRTOTDESCTX)* (V_VRRECUIMDES - 1)))  * (V_VRPERCDOT5 / 100);
      END IF;

      IF V_IDPERCDOTA6 = 'S' THEN
         V_VRSALDODOT := V_VRSALDODOT + (V_VRPERCDOT6 / 100);
      END IF;

      V_VRSALDODOT := (V_VRSALDODOT - P_VRNOTACRED);

      IF V_VRSALDODOT > 0 THEN

         V_NRLANCTONF := LPAD(TO_CHAR((TO_NUMBER(V_NRLANCTONF) + 1)),10,'0');

         GERA_NOTAFISCAL_CORPO(P_CDFILIPROC, V_CDFILIAPUR, V_CDEMPRATAC, '12',
                               V_CDSERIEDOT, P_CDCLIENTE, P_DATAFIM, 'FAI',
                               V_NRLANCTONF, V_NRLANCESTQ, 'N', P_NRAPURACFAT,
                               V_NRLANCTONF,NULL, NULL, NULL, NULL, NULL, NULL,
                               NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                               P_DATAFIM, NULL);


         SELECT MAX(DSITEMISSAO)
         INTO V_NMPRGENEREV
         FROM ITEMISSAO
         WHERE CDPRODUTO =  V_CDPRODDOTA;

         GERA_NOTAFISCAL_PRODUTO(P_CDFILIPROC, V_NRLANCTONF, V_CDPRODDOTA,
                                 V_CDPRODDOTA, V_NMPRGENEREV, 1, ROUND(V_VRSALDODOT,2),
                                 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                 NULL, NULL,  NULL,  'S' , '4' );

         GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_NRLANCTONF);

      END IF;

      /* Gerao do Reembolso de Compras */

      IF (V_VRTOTCMPSTX > 0) AND (V_CDPROREECMP IS NOT NULL) THEN

            V_NRLANCTONF := LPAD(TO_CHAR((TO_NUMBER(V_NRLANCTONF) + 1)),10,'0');

            GERA_NOTAFISCAL_CORPO(P_CDFILIPROC, V_CDFILIAPUR, V_CDEMPRATAC, '12',
                                  V_CDSERIEDOT, P_CDCLIENTE, P_DATAFIM, 'FAI',
                                  V_NRLANCTONF, V_NRLANCESTQ, 'N', P_NRAPURACFAT,
                                  V_NRLANCTONF,NULL, NULL, NULL, NULL, NULL, NULL,
                                  NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                                  P_DATAFIM, NULL);


            SELECT MAX(DSITEMISSAO)
            INTO V_NMPRGENEREV
            FROM ITEMISSAO
            WHERE CDPRODUTO =  V_CDPROREECMP;

            GERA_NOTAFISCAL_PRODUTO(P_CDFILIPROC, V_NRLANCTONF, V_CDPROREECMP,
                                    V_CDPROREECMP, V_NMPRGENEREV, 1, ROUND(V_VRTOTCMPSTX,2), 0,
                                    NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                    NULL,  'S', '3' );

            GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_NRLANCTONF);

            IF (V_VRTOTCMPSTX > V_VRSALDODOT)  AND (V_VRSALDODOT <> 0) AND
               (V_CDAJUSTPADR IS NOT NULL)  THEN

               SELECT MAX(NRSEQVENREC), MAX(NRPARCELAREC), NVL(SUM(VRATUAREC),0)
               INTO V_NRSEQVENREC, V_NRPARCELAREC, V_VRATUAREC
               FROM CONTARECEBER
               WHERE (CDFILIAL    =  P_CDFILIPROC)  AND
                     (NRLANCTONF  =  V_NRLANCTONF);

               IF V_VRATUAREC > (ROUND(V_VRSALDODOT,2)) THEN

                  INSERT INTO AJCTRECEBER
                  (CDFILIAL,   NRLANCTONF,  DTAJUSTEREC, CDAJUCTREC, DSAJUSTEREC,
                   VRAJUSTEREC, NRSEQVENREC, NRPARCELAREC)
                  VALUES
                  (P_CDFILIPROC, V_NRLANCTONF, SYSDATE,   V_CDAJUSTPADR, V_DSAJUCTREC,
                   ROUND(V_VRSALDODOT,2), V_NRSEQVENREC, V_NRPARCELAREC);

                  /*UPDATE CONTARECEBER
                  SET VRATUAREC    = VRATUAREC - ROUND(V_VRSALDODOT,2)
                  WHERE (CDFILIAL     =  P_CDFILIPROC)  AND
                        (NRLANCTONF   =  V_NRLANCTONF)  AND
                        (NRSEQVENREC  =  V_NRSEQVENREC) AND
                        (NRPARCELAREC =  V_NRPARCELAREC); */

               END IF;
            END IF;
      END IF;

      /* Gerao do Crdito em Relao a Dotao da Apurao Passada */

      SELECT NVL(SUM(VRBRUTITEM),0)
      INTO V_VRDOTPURPASS
      FROM NOTAFISCAL N, ITEMPRODUTO IP
      WHERE  (N.CDFILIEMIT   = P_CDFILIAPUR)                         AND
             (N.IDSTATUS     <> 'C')                                 AND
             (N.CDTIPOOPER   = '12')                                 AND
             (N.IDENTRSAIDOP = 'S')                                  AND
             (N.DTENTRSAID BETWEEN V_DTINIAPURAC  AND V_DTFIMAPURAC) AND
             (IP.CDFILIAL    = N.CDFILIAL)                           AND
             (IP.NRLANCTONF  = N.NRLANCTONF)                         AND
             (IP.IDTPNFCREDEB   = '4');

      IF V_VRDOTPURPASS > 0 THEN

         V_NRLANCTONF := LPAD(TO_CHAR((TO_NUMBER(V_NRLANCTONF) + 1)),10,'0');

         GERA_NOTAFISCAL_CORPO(P_CDFILIPROC, V_CDFILIAPUR, V_CDEMPRATAC, '12',
                               V_CDSERIEDOT, P_CDCLIENTE, P_DATAFIM, 'FAI',
                               V_NRLANCTONF, V_NRLANCESTQ, 'N', P_NRAPURACFAT,
                               V_NRLANCTONF,NULL, NULL, NULL, NULL, NULL, NULL,
                               NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                               P_DATAFIM, NULL);


         SELECT MAX(DSITEMISSAO)
         INTO V_NMPRGENEREV
         FROM ITEMISSAO
         WHERE CDPRODUTO =  V_CDPRODCREDI;

         GERA_NOTAFISCAL_PRODUTO(P_CDFILIPROC, V_NRLANCTONF, V_CDPRODCREDI,
                                 V_CDPRODCREDI, V_NMPRGENEREV, 1, V_VRDOTPURPASS, 0,
                                 NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                 NULL, NULL,  NULL,  'S', '2');

         GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_NRLANCTONF);


         V_VRSALDODEV := V_VRDOTPURPASS - (V_VRTOTACMP + V_VRTOTADESP + V_VRTOTCMPSTX);

         IF V_VRSALDODEV > 0 THEN

            /* Gerao de Nota Crdito ou  Aviso de Crdito */

            V_NRLANCTONF := LPAD(TO_CHAR((TO_NUMBER(V_NRLANCTONF) + 1)),10,'0');

            IF V_IDAVISOCRED = 'C' THEN

               GERA_NOTAFISCAL_CORPO(P_CDFILIPROC, V_CDFILIAPUR, V_CDEMPRATAC, '12',
                                     '', '', P_DATAFIM, 'FAI',
                                     V_NRLANCTONF, V_NRLANCESTQ, 'N', P_NRAPURACFAT,
                                     V_NRLANCTONF, NULL, NULL, NULL, NULL, NULL, NULL,
                                     NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                                     NULL, V_IDAVISOCRED);  /* esse documento devera aparecer
                                                               somente na apuraao do mandato*/
            ELSE

               GERA_NOTAFISCAL_CORPO(P_CDFILIPROC, V_CDFILIAPUR, V_CDEMPRATAC, '12',
                                     V_CDSERIEDOT, P_CDCLIENTE, P_DATAFIM, 'FAI',
                                     V_NRLANCTONF, V_NRLANCESTQ, 'N', P_NRAPURACFAT,
                                     V_NRLANCTONF, NULL, NULL, NULL, NULL, NULL, NULL,
                                     NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                                     P_DATAFIM, V_IDAVISOCRED);

            END IF;


            SELECT DSITEMISSAO
            INTO V_NMPRGENEREV
            FROM ITEMISSAO
            WHERE CDPRODUTO =  V_CDPRODCREDI;

            GERA_NOTAFISCAL_PRODUTO(P_CDFILIPROC, V_NRLANCTONF, V_CDPRODCREDI,
                                    V_CDPRODCREDI, V_NMPRGENEREV, 1, ROUND(V_VRSALDODEV,2), 0,
                                    NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                    NULL, NULL,  NULL,  'S' , '2' );

            GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_NRLANCTONF);

         ELSIF V_VRSALDODEV = 0 THEN

            /* Aviso de  Debito/Crdito */

            V_NRLANCTONF := LPAD(TO_CHAR((TO_NUMBER(V_NRLANCTONF) + 1)),10,'0');

            GERA_NOTAFISCAL_CORPO(P_CDFILIPROC, V_CDFILIAPUR, V_CDEMPRATAC, '12',
                                  V_CDSERIEDOT, P_CDCLIENTE, P_DATAFIM, 'FAI',
                                  V_NRLANCTONF, V_NRLANCESTQ, 'N', P_NRAPURACFAT,
                                  V_NRLANCTONF, NULL, NULL, NULL, NULL, NULL, NULL,
                                  NULL, NULL, NULL, NULL,  NULL, NULL, P_DATAFIM,
                                  NULL);

            SELECT DSITEMISSAO
            INTO V_NMPRGENEREV
            FROM ITEMISSAO
            WHERE CDPRODUTO =  V_CDPRODCREDI;

            GERA_NOTAFISCAL_PRODUTO(P_CDFILIPROC, V_NRLANCTONF, V_CDPRODCREDI,
                                    V_CDPRODCREDI, V_NMPRGENEREV, 1,ROUND(V_VRTOTACMP + V_VRTOTADESP,2), 0,
                                    NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                    NULL, NULL,  NULL,  'S' , '2' );




            SELECT DSITEMISSAO
            INTO V_NMPRGENEREV
            FROM ITEMISSAO
            WHERE CDPRODUTO =  V_CDPRODDOTA;

            GERA_NOTAFISCAL_PRODUTO(P_CDFILIPROC, V_NRLANCTONF, V_CDPRODDOTA,
                                    V_CDPRODDOTA, V_NMPRGENEREV, 1, ROUND(V_VRDOTPURPASS,2), 0,
                                    NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                    NULL, NULL,  NULL,  'S' , '1' );

            GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_NRLANCTONF);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('APURAC_MANDATO','4.07.036'); END;
/

